Index: haskell-platform/Portfile
===================================================================
--- haskell-platform/Portfile	(revision 125574)
+++ haskell-platform/Portfile	(working copy)
@@ -6,7 +6,7 @@
 name            haskell-platform
 
 if {$subport == $name} {
-    version         2013.2.0.0
+    version         2014.2.0.0
     categories      devel haskell
     maintainers     cal openmaintainer
     description     \
@@ -79,7 +79,7 @@
             ${block}
         }
 
-        if {\${subport} == \${name}} {
+        if {\${subport} eq \${name}} {
             depends_run-append  port:hs-${pkgname}
         }
     "
@@ -117,7 +117,7 @@
             ${block}
         }
 
-        if {\${subport} == \${name}} {
+        if {\${subport} eq \${name}} {
             depends_run-append  port:hs-${pkgname}
         }
     "
@@ -128,9 +128,9 @@
 # Additional Platform Libraries #
 #################################
 
-haskell_platform_port async 2.0.1.4 1 {
-    checksums               rmd160  8a28038e3193ee6de2212afb42f25fc444a2ef1d \
-                            sha256  41ddfe012d98f3ef101651fb529753bca5bb4c804f03f9cfafc5d0cbe50224c2
+haskell_platform_port async 2.0.1.5 0 {
+    checksums               rmd160  0ec360bc373c4ca0b3c7617ec611f2414804e9cd \
+                            sha256  cd13ac558f4f63e567100805770648e89307a3210852b17038c9be4fcc3aa83c
 
     depends_lib-append      port:hs-stm
 
@@ -148,7 +148,7 @@
         automatically killed when their parent dies (see withAsync).
 }
 
-haskell_platform_port attoparsec 0.10.4.0 2 {
+haskell_platform_port attoparsec 0.10.4.0 3 {
     checksums               rmd160  1fc9845e60fb0cddc9ffa8838c446b3046cd3522 \
                             sha256  b6b84e0dbd1c3beec1dedea578ac2f4d62afbe66b383582b7b3349406866d346
 
@@ -161,9 +161,9 @@
         formats.
 }
 
-haskell_platform_port case-insensitive 1.0.0.1 1 {
-    checksums               rmd160  890cc0d0c3d8e0470956f7bce2da70c3adf8e90c \
-                            sha256  b58f62516779580a41cdc67a979c509125adf139b8f50d415495f58d4b42e8fa
+haskell_platform_port case-insensitive 1.1.0.3 0 {
+    checksums               rmd160  351ebf0ae84c4c580b910dbd3ed0828b309874c7 \
+                            sha256  7b255fe63155d53ab84b248ab5ba9306fd4bec47a6198e3275cf9cb41c4d263b
 
     depends_lib-append      port:hs-hashable \
                             port:hs-text
@@ -176,22 +176,9 @@
         insensitive to cases.
 }
 
-haskell_platform_port cgi 3001.1.7.5 1 {
-    checksums               rmd160  76823f125e750f648d967f833a5c6a11814d8b56 \
-                            sha256  5126e2eaa53cd5de59572981c00aedae5790882afda67545228eb29fe76faffd
-
-    depends_lib-append      port:hs-mtl \
-                            port:hs-parsec \
-                            port:hs-network \
-                            port:hs-xhtml
-
-    description             A library for writing CGI programs
-    long_description        This is a Haskell library for writing CGI programs.
-}
-
-haskell_platform_port fgl 5.4.2.4 3 {
-    checksums               rmd160  e2b9e0d1d43e69b250719a34c6de9344b38264bf \
-                            sha256  ce98ccb83e2d271a7b3266426a0762a0e902252f07ec09b7bef50c67d0110266
+haskell_platform_port fgl 5.5.0.1 0 {
+    checksums               rmd160  c6c1f89db51d8d3ce6687dab13109c7f40c9c10c \
+                            sha256  aa61664ba38db3e54124b702b1ee92a72a569c981b759e48cfb567078b038763
 
     depends_lib-append      port:hs-mtl
 
@@ -199,9 +186,9 @@
     long_description        ${description}
 }
 
-haskell_platform_port GLUT 2.4.0.0 1 {
-    checksums               rmd160  b1f4449f2bacbbbf51ffd5146c1f7ccafd6d0348 \
-                            sha256  100df2d724dfad26b0c8d47b17d4cef9dcbc12a75cce7a096046c27485b4cbbc
+haskell_platform_port GLUT 2.5.1.1 0 {
+    checksums               rmd160  b6e4bad4109307a614c3ba93aa1f3f8857ae45dc \
+                            sha256  4a8177e154ead5a7bcc110f8fe408f9cf720783dde024ac1936cd95b659b2d59
 
     depends_lib-append      port:hs-opengl
 
@@ -211,9 +198,9 @@
         independent toolkit for writing OpenGL programs.
 }
 
-haskell_platform_port GLURaw 1.3.0.0 1 {
-    checksums               rmd160  2aa60cb5a779ee858a9e1bcadfe3b2bfccfbd167 \
-                            sha256  e03905710043eb2e9878e5fc75f969c4f120321bc6a7709cde3a9890be3c08ea
+haskell_platform_port GLURaw 1.4.0.1 0 {
+    checksums               rmd160  1fa7a906c6f99d9540b200de038a2a734e576cea \
+                            sha256  9655644beb54ff8fac68f2e0fd8a8e9a1e8409272e2e4c963ccce9bcd60e0ecc
 
     depends_lib-append      port:hs-openglraw
 
@@ -224,9 +211,9 @@
         a nicer interface.
 }
 
-haskell_platform_port hashable 1.1.2.5 1 {
-    checksums               rmd160  93b4faee93a046445458e9f9c67820b458242aac \
-                            sha256  3fb5d430c9289ebada4991a76fd78f028aaaf17957dc666ddc7b89c98a54713d
+haskell_platform_port hashable 1.2.2.0 0 {
+    checksums               rmd160  33f9040f2afcb93d6475d8872aef4c164a4cff5e \
+                            sha256  033a90b0369af59bf922d0c2af8d73a18432b46b0a47607f436d38f873a88e21
 
     depends_lib-append      port:hs-text
 
@@ -238,9 +225,9 @@
         a way to combine hash values.
 }
 
-haskell_platform_port haskell-src 1.0.1.5 3 {
-    checksums               rmd160  32a53bab9f1e150565cbed0c926816e4089dd966 \
-                            sha256  9f3726902247cc955d085997254bb58c16cc337ee83de5ccfb17dcbcb488c3ab
+haskell_platform_port haskell-src 1.0.1.6 0 {
+    checksums               rmd160  649a0f9f116cb90f03411a9e8d53b17409c38134 \
+                            sha256  c7c556366025d9895d1110ecfa30a29e29d7d0a8cb447716fe601e4ff5da4cef
 
     depends_lib-append      port:hs-syb
 
@@ -252,7 +239,7 @@
         of this package are to parse or generate Haskell 98 code.
 }
 
-haskell_platform_port html 1.0.1.2 4 {
+haskell_platform_port html 1.0.1.2 5 {
     checksums               rmd160  55d95a42c297c9c4b0b0c3bbd077a5ed59e48878 \
                             sha256  0c35495ea33d65e69c69bc7441ec8e1af69fbb43433c2aa3406c0a13a3ab3061
 
@@ -261,9 +248,9 @@
         This package contains a combinator library for constructing HTML documents.
 }
 
-haskell_platform_port HTTP 4000.2.8 4 {
-    checksums               rmd160  844041fdfb257c19cf35be24976925bc9c0c43c6 \
-                            sha256  086a2aa771a31845b190e2f9651ab4d8e85116aa463de5bc5e0204c1e5e70c5c
+haskell_platform_port HTTP 4000.2.10 0 {
+    checksums               rmd160  b1e3a1aec27c3e09fe1f93f93ab717cc4e576504 \
+                            sha256  efde6d9f2e8cd7b72068579f0a75449703c0fa7aee76dfc0f3af175295a127d1
 
     depends_lib-append      port:hs-network \
                             port:hs-mtl \
@@ -278,7 +265,7 @@
         the implementation is all written in Haskell.
 }
 
-haskell_platform_port HUnit 1.2.5.2 1 {
+haskell_platform_port HUnit 1.2.5.2 2 {
     checksums               rmd160  f6ac9ac12c152609174ea80a3a0c694210c81594 \
                             sha256  0af5ad34dba27de48b94ce6d5f7ee3aa6af6183bdc4a3967b811e28520369a41
 
@@ -288,9 +275,9 @@
         tool for Java, see: http://www.junit.org.
 }
 
-haskell_platform_port mtl 2.1.2 3 {
-    checksums               rmd160  aa5c576c124b602a605cf3931ac42c1c1eb27cda \
-                            sha256  8c775764333420a4391823f9cb9b640306a262552280ea9bbdd2ca11194a8bef
+haskell_platform_port mtl 2.1.3.1 0 {
+    checksums               rmd160  f6432fb7e64d66eff69f02ccca9fc30ac5dce502 \
+                            sha256  77af766957fb49361fe63446f272a698bddb13398669edc363022e5c2517f6f6
 
     depends_lib-append      port:hs-transformers
 
@@ -302,9 +289,9 @@
         School of Functional Programming, 1995
 }
 
-haskell_platform_port network 2.4.1.2 2 {
-    checksums               rmd160  27461d006ac9580d55a0f1377774c1ac9c20a024 \
-                            sha256  b04dc56542428bc92f11263f500b3ad82e6a0787805601472d59af7e769bfe38
+haskell_platform_port network 2.4.2.3 0 {
+    checksums               rmd160  38f20be22e51a902a00416bad1e63480316e8348 \
+                            sha256  801b9c652dae626bf4a96175162b1290e7fe7ff20d802d62434d5ae1d363c16d
 
     depends_lib-append      port:hs-parsec
 
@@ -312,22 +299,23 @@
     long_description        ${description}
 }
 
-haskell_platform_port OpenGL 2.8.0.0 1 {
-    checksums               rmd160  3be0a47aea270ce184da50007dd729814ef99aaa \
-                            sha256  ce753d8db75b5096e030422765193c4975779b42bfffa467408a40d8c43965f1
+haskell_platform_port OpenGL 2.9.2.0 0 {
+    checksums               rmd160  b238630bd16d37485c58835a643d965ac6c61ef2 \
+                            sha256  1758f6cacc9ea8f0d410fd0abc1a19f2a50dffdb62736d66d4e62b20619545e9
 
     depends_lib-append      port:hs-gluraw \
-                            port:hs-openglraw
+                            port:hs-openglraw \
+                            port:hs-text
 
     description             A binding for the OpenGL graphics system
     long_description        \
-        A Haskell binding for the OpenGL graphics system (GL, version 3.2) and \
-        its accompanying utility library (GLU, version 1.3).
+        A Haskell binding for the OpenGL graphics system (GL, version 4.4) and \
+        its accompanying utility library (GLU, version 1.3). 
 }
 
-haskell_platform_port OpenGLRaw 1.3.0.0 1 {
-    checksums               rmd160  09c08ce9f45acdabdef46e397e72814f5a86e71b \
-                            sha256  6228ca9ac967350fcb6abac25b8027660ad8599914a60ef0fd10919a6d2cd745
+haskell_platform_port OpenGLRaw 1.5.0.0 0 {
+    checksums               rmd160  6ede61cb59090ede7d3ec1df41311a8e14496080 \
+                            sha256  852aa5229722269d70daed3c04b95e9dc7b7013efd62ebc4f2873a81768b9a12
 
     description             A raw binding for the OpenGL graphics system
     long_description        \
@@ -343,17 +331,17 @@
         thrown.
 }
 
-haskell_platform_port parallel 3.2.0.3 2 {
-    checksums               rmd160  a358225292a80bb4223e6ea2f6e0d502e41cab02 \
-                            sha256  163a40ef3c6258c623abe690a9837c9de2bf7fe87d3fac7d0758229d7efb6dcd
+haskell_platform_port parallel 3.2.0.4 0 {
+    checksums               rmd160  4bc31de0b3dd63ca8d24c967f32a2ee40f0a2d64 \
+                            sha256  8cdb637fc04e4dd62f9deb0fe3c191b8068526009960f297f54dc9cf5616146d
 
     description             Parallel programming library
     long_description        This package provides a library for parallel programming.
 }
 
-haskell_platform_port parsec 3.1.3 4 {
-    checksums               rmd160  b1b407b27f5642142bfa619b31abd7a8cafe11ce \
-                            sha256  9f14bb4da77eb9b0e4dbe8112559ed49409b0af8e9aef5d08941dd97e37fc4a8
+haskell_platform_port parsec 3.1.5 0 {
+    checksums               rmd160  4d27dffd266c38cc3266ea17b792e00f180b3968 \
+                            sha256  c572245d72bc3aff3491ce4f89215fcaa1e01c5e7b280d4c105a87db31793cb8
 
     depends_lib-append      port:hs-mtl \
                             port:hs-text
@@ -367,7 +355,15 @@
         monads, and it is also parametric in the input stream type.
 }
 
-haskell_platform_port QuickCheck 2.6 1 {
+haskell_platform_port primitive 0.5.2.1 0 {
+    checksums               rmd160  b456047baa641acc897a871cc2212f9f3a2c576f \
+                            sha256  0e516b81c2ef2c96d47dc40561663cc2cbfece0f135948e77e9b53025ff1c3ee
+
+    description             Primitive memory-related operations
+    long_description        This package provides various primitive memory-related operations.
+}
+
+haskell_platform_port QuickCheck 2.6 2 {
     checksums               rmd160  94bab2dcefdd7a6eddd5af7211db1babf39e0df8 \
                             sha256  8001c00a1892714d914e5007ba72cdd428c1ea4c6b8418c6cb5e7809753d970d
 
@@ -381,7 +377,7 @@
         that the properties hold in a large number of randomly generated cases.
 }
 
-haskell_platform_port random 1.0.1.1 3 {
+haskell_platform_port random 1.0.1.1 4 {
     checksums               rmd160  a13a4d7fefd15611cf863f11caf212efede320c3 \
                             sha256  df7c3b405de0ac27a2ee8fdc8dad87cb42e8eac01fef53861e43bc47c8111559
           
@@ -391,7 +387,7 @@
         the ability to split random number generators.
 }
 
-haskell_platform_port regex-base 0.93.2 3 {
+haskell_platform_port regex-base 0.93.2 4 {
     checksums               rmd160  c009e193dd453666c7c3b585a25f3a8add7ec6b6 \
                             sha256  20dc5713a16f3d5e2e6d056b4beb9cfdc4368cd09fd56f47414c847705243278
 
@@ -401,7 +397,7 @@
     long_description        Interface API for regex-posix,pcre,parsec,tdfa,dfa
 }
 
-haskell_platform_port regex-compat 0.95.1 3 {
+haskell_platform_port regex-compat 0.95.1 4 {
     checksums               rmd160  b2fe02ca3c4e9027b2d433c8a265b19a85c8bd17 \
                             sha256  d57cb1a5a4d66753b18eaa37a1621246f660472243b001894f970037548d953b
 
@@ -412,7 +408,7 @@
     long_description        One module layer over regex-posix to replace Text.Regex
 }
 
-haskell_platform_port regex-posix 0.95.2 2 {
+haskell_platform_port regex-posix 0.95.2 3 {
     checksums               rmd160  7ee59eb760bb8c0c7fe17e17d90eb0623b9fd5bb \
                             sha256  56019921cd4a4c9682b81ec614236fea816ba8ed8785a1640cd66d8b24fc703e
 
@@ -422,7 +418,7 @@
     long_description        The posix regex backend for regex-base
 }
 
-haskell_platform_port split 0.2.2 1 {
+haskell_platform_port split 0.2.2 2 {
     checksums               rmd160  7d4fe221283836386807f0e73a90df1255061f6f \
                             sha256  f9cf9e571357f227aed5be9a78f5bbf78ef55c99df2edf7fdc659acc1f904375
 
@@ -432,7 +428,7 @@
         the "split" function found in several mainstream languages.
 }
 
-haskell_platform_port stm 2.4.2 1 {
+haskell_platform_port stm 2.4.2 2 {
     checksums               rmd160  7d49257f7e2de7cf18e02dc3ceeb4619d7980dd8 \
                             sha256  c8ee3cd64c266133902619cfff2d04e5f66206f91dbce8dd1182037fbe4858db
 
@@ -440,9 +436,9 @@
     long_description        A modular composable concurrency abstraction.
 }
 
-haskell_platform_port syb 0.4.0 3 {
-    checksums               rmd160  7814875c994d34b0dd11e378c3d16e009a843d4d \
-                            sha256  f201089aa7e74b6cbca7fc73a259596b2a9628e31a9b54e801844ad68447bff3
+haskell_platform_port syb 0.4.1 0 {
+    checksums               rmd160  4ed2329f3c915adb91fb5b1f6b3735e219d1fdd6 \
+                            sha256  aa32cb3d9a0cbcfb24ac1c5d567886e8908dd017fd009ffd446bff86732670d2
 
     description             Scrap Your Boilerplate
     long_description        \
@@ -454,9 +450,9 @@
         a variety of traversals.
 }
 
-haskell_platform_port text 0.11.3.1 1 {
-    checksums               rmd160  544b6be80db9432dd4c149f81a2c0603e2e67205 \
-                            sha256  76aad4a647cad7099b5a693eb9a4bc5263f7751392d8d1f87b14c78e2069559f
+haskell_platform_port text 1.1.0.0 0 {
+    checksums               rmd160  b57efc9cbf277cd914a9e148129e42ae861771b8 \
+                            sha256  80f1ada824f0e3886bb49dc7fd128707ca1a34e06bbf4419873b1677c4d7ba92
 
     description             An efficient packed Unicode text type
     long_description        \
@@ -464,7 +460,7 @@
         with a powerful loop fusion optimization framework.
 }
 
-haskell_platform_port transformers 0.3.0.0 3 {
+haskell_platform_port transformers 0.3.0.0 4 {
     checksums               rmd160  110bd7eb44609d8db44d85f8367db323576545dc \
                             sha256  e5aa0c1ec97ad98c389e78f59aca25ab028980a7068a3e585e39564662739591
 
@@ -477,9 +473,9 @@
         (http://web.cecs.pdx.edu/~mpj/pubs/springschool.html).
 }
 
-haskell_platform_port unordered-containers 0.2.3.0 2 {
-    checksums               rmd160  91b7d7c2138de34b3b690efe294d90022e04d8b3 \
-                            sha256  edb6a442ef9fcf4ce59f66871d51df5c012345fce95970127e75b62e5396efef
+haskell_platform_port unordered-containers 0.2.4.0 0 {
+    checksums               rmd160  0d62b6b8f95e65890e07934413cd1377ed1e85e5 \
+                            sha256  34eaeb0c96d84169aca7085cf21f89bedb4bdb4de2ac78358a087faeea93cdf4
 
     depends_lib-append      port:hs-hashable
 
@@ -490,9 +486,9 @@
         quantities and high speed.
 }
 
-haskell_platform_port vector 0.10.0.1 3 {
-    checksums               rmd160  e00adaf6b4a9634df2feb1a805f4adf51d1870ae \
-                            sha256  ece945058b01a77c5fff31e89bbea76ac619677041c41286a2da5e8b515508af
+haskell_platform_port vector 0.10.9.1 0 {
+    checksums               rmd160  885ba057a05219ae6a35170539c68996d2074668 \
+                            sha256  205656e9741aad406e427e988dbf1665bf5dbdf3e9d574e309c274be4e06bde5
 
     depends_lib-append      port:hs-primitive
 
@@ -502,7 +498,7 @@
         immutable), with a powerful loop optimisation framework.
 }
 
-haskell_platform_port xhtml 3000.2.1 3 {
+haskell_platform_port xhtml 3000.2.1 4 {
     checksums               rmd160  72e1095df0a8111ea696749d219df4ea78da1b4f \
                             sha256  33020782170c1c083bc59fc3bfcb72cec2db223e02d1181c07ae23b9fa7fdcd8
 
@@ -512,7 +508,7 @@
         Strict, Transitional and Frameset variants.
 }
 
-haskell_platform_port zlib 0.5.4.1 2 {
+haskell_platform_port zlib 0.5.4.1 3 {
     checksums               rmd160  9ed49e79e239604958a9c385cca75747fafc2713 \
                             sha256  cca365e4c52c90be41a5754943134da5ce6c60bb52fa00c128fd118e0505a550
 
@@ -530,14 +526,15 @@
 # Programs and Tools #
 ######################
 
-haskell_platform_tool cabal-install 1.16.0.2 1 {
-    checksums               rmd160  2e19f5086cbf7f4ea9c17bf804ec6da886cd2f51 \
-                            sha256  66dfacc9f33e668e56904072cadb8a36bd9d6522ba5464c6a36a5de7e65c5698
+haskell_platform_tool cabal-install 1.18.0.5 0 {
+    checksums               rmd160  f07279510e03678ad5e3720d9e01707681f874ea \
+                            sha256  477df8ef73916e8bc23c727280a1700939131a3e2809a057668c883b0b521782
 
     depends_lib-append      port:hs-http \
                             port:hs-mtl \
                             port:hs-network \
                             port:hs-random \
+                            port:hs-stm \
                             port:hs-zlib
 
     description             The command-line interface for Cabal and Hackage
@@ -547,33 +544,43 @@
         installation of Haskell libraries and programs.
 }
 
-haskell_platform_tool alex 3.0.5 2 {
-    checksums               rmd160  3f543c6af966f6200f84f408022d62beaefb875f \
-                            sha256  c3326417a0538e355e5ad1871ab931b9c8145391e8b2ff79668eb643d9b99659
+haskell_platform_tool alex 3.1.3 0 {
+    checksums               rmd160  2325ccfc770264c517d2dfa38cece9376d4e252d \
+                            sha256  8d41a6e72a016155f00c846f7146ab4b27fe9640668a4b592d6a9b856f970a92
 
     depends_lib-append      port:hs-quickcheck
 
-    description             A lexical analyser generator for Haskell
+    description             A tool for generating lexical analysers in Haskell
     long_description        \
-        Alex is a tool for generating lexical analysers in Haskell, given \
-        a description of the tokens to be recognised in the form of regular \
-        expressions. It is similar to the tool lex or flex for C/C++.
+        Alex is a tool for generating lexical analysers in Haskell. It takes \
+        a description of tokens based on regular expressions and generates \
+        a Haskell module containing code for scanning text efficiently. It is \
+        similar to the tool lex or flex for C/C++.
 }
 
-haskell_platform_tool happy 1.18.10 3 {
-    checksums               rmd160  3c113721ccacbe33bfbc25287bfe9bf74cc365f7 \
-                            sha256  c1c920f77906740252e261e2baec5b7519e584344d6080aa5a9cc0b677b9064b
+haskell_platform_tool happy 1.19.4 0 {
+    checksums               rmd160  8ec09c4743d85ae493354e49df07f0ee423267cf \
+                            sha256  6be499f66c61f8c48cbbbcb70515eb8e62c2bfa08adcc8c9474e7ae343a6936d
 
     depends_lib-append      port:hs-mtl
-    description             \
-        Happy is a parser generator system for Haskell, similar to the tool `yacc' \
-        for C. Like `yacc', it takes a file containing an annotated BNF \
-        specification of a grammar and produces a Haskell module containing \
-        a parser for the grammar.
-    long_description        ${description} \
-        Happy is flexible: you can have several Happy parsers in the same program, \
-        and several entry points to a single grammar. Happy can work in conjunction \
-        with a lexical analyser supplied by the user (either hand-written or \
-        generated by another program), or it can parse a stream of characters \
-        directly (but this isn't practical in most cases).
+    description             A parser generator for Haskell
+    long_description        \
+        Happy is a parser generator for Haskell. Given a grammar specification \
+        in BNF, Happy generates Haskell code to parse the grammar. Happy works \
+        in a similar way to the yacc tool for C.
+}
+
+haskell_platform_tool hscolour 1.20.3 0 {
+    checksums               rmd160  2d875ecdb910a5955a5ec049935a74c60edbc4cc \
+                            sha256  3adb816fba3ecdf9f1ee5fb23feb0611b0762f7e8c2a282c2def5cc2f5483d96
+
+    license                 GPL-2+
+
+    description             Colourise Haskell code
+    long_description        \
+        hscolour is a small Haskell script to colourise Haskell code. It \
+        currently has six output formats: ANSI terminal codes (optionally \
+        XTerm-256colour codes), HTML 3.2 with font tags, HTML 4.01 with CSS, \
+        HTML 4.01 with CSS and mouseover annotations, XHTML 1.0 with inline CSS \
+        styling, LaTeX, and mIRC chat codes.
 }
Index: hs-primitive/Portfile
===================================================================
--- hs-primitive/Portfile	(revision 125574)
+++ hs-primitive/Portfile	(working copy)
@@ -1,17 +0,0 @@
-# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
-# $Id$
-
-PortSystem          1.0
-PortGroup           haskell 1.0
-
-haskell.setup       primitive 0.5.1.0
-revision            2
-checksums           rmd160  712a5b2e2e8475729c3250c238663419120c27ff \
-                    sha256  8817a5f307c4605709b37857c048caa22fcc7550d681d64a2eea756126721529
-
-license             BSD
-maintainers         cal openmaintainer
-platforms           darwin
-
-description         Primitive memory-related operations
-long_description    This package provides various primitive memory-related operations.