Index: sysutils/python_select/Portfile
===================================================================
--- sysutils/python_select/Portfile	(revision 125623)
+++ sysutils/python_select/Portfile	(working copy)
@@ -4,8 +4,7 @@
 PortGroup select 1.0
 
 name                    python_select
-version                 0.3
-revision                3
+version                 0.4
 categories              sysutils
 platforms               darwin
 license                 BSD
Index: sysutils/python_select/files/base
===================================================================
--- sysutils/python_select/files/base	(revision 125623)
+++ sysutils/python_select/files/base	(working copy)
@@ -1,4 +1,6 @@
 bin/python
+bin/python2
+bin/python3
 bin/pythonw
 bin/python-config
 bin/idle
Index: sysutils/python_select/files/none
===================================================================
--- sysutils/python_select/files/none	(revision 125623)
+++ sysutils/python_select/files/none	(working copy)
@@ -11,3 +11,5 @@
 -
 -
 -
+-
+-
Index: sysutils/python_select/files/python23-apple
===================================================================
--- sysutils/python_select/files/python23-apple	(revision 125623)
+++ sysutils/python_select/files/python23-apple	(working copy)
@@ -1,4 +1,6 @@
 /usr/bin/python2.3
+/usr/bin/python2.3
+-
 /usr/bin/pythonw2.3
 -
 -
Index: sysutils/python_select/files/python25-apple
===================================================================
--- sysutils/python_select/files/python25-apple	(revision 125623)
+++ sysutils/python_select/files/python25-apple	(working copy)
@@ -1,4 +1,6 @@
 /usr/bin/python2.5
+/usr/bin/python2.5
+-
 /usr/bin/pythonw2.5
 /usr/bin/python2.5-config
 -
Index: sysutils/python_select/files/python25-apple.mtln
===================================================================
--- sysutils/python_select/files/python25-apple.mtln	(revision 125623)
+++ sysutils/python_select/files/python25-apple.mtln	(working copy)
@@ -1,4 +1,6 @@
 /usr/bin/python2.5
+/usr/bin/python2.5
+-
 /usr/bin/pythonw2.5
 /usr/bin/python2.5-config
 /usr/bin/idle2.5
Index: sysutils/python_select/files/python26-apple
===================================================================
--- sysutils/python_select/files/python26-apple	(revision 125623)
+++ sysutils/python_select/files/python26-apple	(working copy)
@@ -1,4 +1,6 @@
 /usr/bin/python2.6
+/usr/bin/python2.6
+-
 /usr/bin/pythonw2.6
 /usr/bin/python2.6-config
 /usr/bin/idle2.6
Index: sysutils/python_select/files/python26-apple.mtln
===================================================================
--- sysutils/python_select/files/python26-apple.mtln	(revision 125623)
+++ sysutils/python_select/files/python26-apple.mtln	(working copy)
@@ -1,4 +1,6 @@
 /usr/bin/python2.6
+/usr/bin/python2.6
+-
 /usr/bin/pythonw2.6
 /usr/bin/python2.6-config
 /usr/bin/idle2.6
Index: sysutils/python_select/files/python27-apple
===================================================================
--- sysutils/python_select/files/python27-apple	(revision 125623)
+++ sysutils/python_select/files/python27-apple	(working copy)
@@ -1,4 +1,6 @@
 /usr/bin/python2.7
+/usr/bin/python2.7
+-
 /usr/bin/pythonw2.7
 /usr/bin/python2.7-config
 /usr/bin/idle2.7
Index: sysutils/python_select/files/python27-apple.mtln
===================================================================
--- sysutils/python_select/files/python27-apple.mtln	(revision 125623)
+++ sysutils/python_select/files/python27-apple.mtln	(working copy)
@@ -1,4 +1,6 @@
 /usr/bin/python2.7
+/usr/bin/python2.7
+-
 /usr/bin/pythonw2.7
 /usr/bin/python2.7-config
 /usr/bin/idle2.7
Index: lang/python24/files/python24
===================================================================
--- lang/python24/files/python24	(revision 125623)
+++ lang/python24/files/python24	(working copy)
@@ -1,4 +1,6 @@
 bin/python2.4
+bin/python2.4
+-
 bin/pythonw2.4
 -
 bin/idle2.4
Index: lang/python25/files/python25
===================================================================
--- lang/python25/files/python25	(revision 125623)
+++ lang/python25/files/python25	(working copy)
@@ -1,4 +1,6 @@
 bin/python2.5
+bin/python2.5
+-
 bin/pythonw2.5
 bin/python2.5-config
 bin/idle2.5
Index: lang/python26/files/python26
===================================================================
--- lang/python26/files/python26	(revision 125623)
+++ lang/python26/files/python26	(working copy)
@@ -1,4 +1,6 @@
 bin/python2.6
+bin/python2.6
+-
 bin/pythonw2.6
 bin/python2.6-config
 bin/idle2.6
Index: lang/python27/files/python27
===================================================================
--- lang/python27/files/python27	(revision 125623)
+++ lang/python27/files/python27	(working copy)
@@ -1,4 +1,6 @@
 bin/python2.7
+bin/python2.7
+-
 bin/pythonw2.7
 bin/python2.7-config
 bin/idle2.7
Index: lang/python31/files/python31
===================================================================
--- lang/python31/files/python31	(revision 125623)
+++ lang/python31/files/python31	(working copy)
@@ -1,3 +1,5 @@
+-
+-
 bin/python3.1
 bin/pythonw3.1
 bin/python3.1-config
Index: lang/python32/files/python32
===================================================================
--- lang/python32/files/python32	(revision 125623)
+++ lang/python32/files/python32	(working copy)
@@ -1,3 +1,5 @@
+-
+-
 bin/python3.2
 bin/pythonw3.2
 bin/python3.2-config
Index: lang/python33/files/python33
===================================================================
--- lang/python33/files/python33	(revision 125623)
+++ lang/python33/files/python33	(working copy)
@@ -1,3 +1,5 @@
+-
+-
 bin/python3.3
 bin/pythonw3.3
 bin/python3.3-config
Index: lang/python34/files/python34
===================================================================
--- lang/python34/files/python34	(revision 125623)
+++ lang/python34/files/python34	(working copy)
@@ -1,3 +1,5 @@
+-
+-
 bin/python3.4
 -
 bin/python3.4-config