Index: Portfile
===================================================================
--- Portfile	(revision 126525)
+++ Portfile	(working copy)
@@ -9,17 +9,19 @@
 PortGroup           github 1.0
 PortGroup           select 1.0
 
+# don't forget to update both the git tag and the version
+#github.setup        root-mirror root 6-02-00 v
+# tag below is 6.02/00 + a few minor fixes for installation issues.
+github.setup        root-mirror root f460f42728305617c4978ced32bd030b1b4279e0
+version             6.02.00
 
-# don't forget to update both the git tag and the version
-github.setup        root-mirror root 6-00-02 v
-version             6.00.02
-revision            2
 # this could be a better way to set the version (unless we use a sha sum for the git tag ;)
 # version           [string map {- .} $version]
 set version_major   [lindex [split ${version} .] 0]
-checksums           rmd160  5efc28e5d68aaa4274d869c809c4d052d6011fe4 \
-                    sha256  6e6fa7fbe0fe72828a6a65f758af9e1fcb04b66dec7fae79ecbe06e81692b218
 
+checksums           rmd160  46c38ab178b114794b2f53cfdd59b41e53470223 \
+                    sha256  cfa9d3daadb05ff527d75ec5959bb1ca3d0ea2f200a09ec1959dc0ef9dba2389
+
 name                root${version_major}
 categories          science
 maintainers         hep.phy.cam.ac.uk:jonesc mojca
@@ -60,8 +62,6 @@
 select.group        root
 select.file         ${filespath}/${name}
 
-patchfiles          patch-cmake-modules-SearchInstalledSoftware.cmake.diff
-
 # Force a compatible compiler
 compiler.blacklist-append *gcc* {clang < 500} macports-clang-2.9 macports-clang-3.0 macports-clang-3.1 macports-clang-3.2
 compiler.fallback-append macports-clang-3.4 macports-clang-3.5
@@ -125,17 +125,14 @@
 
 platform darwin {
 
-    if {${os.major} < 10} {
+    # No longer compiles on OSX10.6, due to update to internal LLVM version.
+    # Disable build on this platform.
+    if { ${os.major} < 11 } {
         pre-fetch {
-            ui_error "${name} requires C++11 and modifications of the package."
-            return -code error "C++11 needed"
+            ui_error "${name} is not supported on this OSX release."
+            return -code error "Unsupported OSX version"
         }
-    } elseif {${os.major} == 10} {
-        # an ugly workaround for lack of __thread on 10.6 (and earlier)
-        # it has to be patched properly upstream
-        # https://sft.its.cern.ch/jira/browse/ROOT-6394
-        patchfiles-append patch-montecarlo-vmc-inc-TMCtls.h.diff
-    }
+    } 
 
     # Note that we are forcing this choice.  This means that anything linking
     # against root6 needs to also be using libc++.  This is possibly
@@ -331,7 +328,7 @@
 # ========================================================================================
 
 # List of possible python versions
-set python_versions { 2.6 2.7 3.1 3.2 3.3 3.4 }
+set python_versions { 2.6 2.7 3.3 3.4 }
 set default_python_variant +python27
 
 # Define the available variants
@@ -567,7 +564,7 @@
 # Note that g95 does not work here, so that variant is removed
 # ========================================================================================
 
-set gcc_versions { 4.7 4.8 4.9 }
+set gcc_versions { 4.7 4.8 4.9 5 }
 set default_fortran_variant +gcc48
 
 foreach gcc_ver ${gcc_versions} {
Index: files/patch-montecarlo-vmc-inc-TMCtls.h.diff
===================================================================
--- files/patch-montecarlo-vmc-inc-TMCtls.h.diff	(revision 126525)
+++ files/patch-montecarlo-vmc-inc-TMCtls.h.diff	(working copy)
@@ -1,15 +1,13 @@
-https://sft.its.cern.ch/jira/browse/ROOT-6394
-
---- montecarlo/vmc/inc/TMCtls.h.orig
-+++ montecarlo/vmc/inc/TMCtls.h
-@@ -49,8 +49,8 @@
-         ( defined(__MACH__) && defined(__GNUC__) && __GNUC__>=4 && __GNUC_MINOR__>=7 ) || \
-         defined(__linux__) || defined(_AIX) ) && ( !defined(__CINT__) )
-       //  Multi-threaded build: for POSIX systems 
+--- ./montecarlo/vmc/inc/TMCtls.h.orig	2014-10-03 11:59:47.000000000 +0100
++++ ./montecarlo/vmc/inc/TMCtls.h	2014-10-03 12:00:24.000000000 +0100
+@@ -52,8 +52,8 @@
+ */
+   #if ( defined(__linux__) ) && ( !defined(__CINT__) )
+       //  Multi-threaded build: for POSIX systems
 -      #include <pthread.h>
 -      #define TMCThreadLocal __thread
-+//    #include <pthread.h>
++      //#include <pthread.h>
 +      #define TMCThreadLocal
    #else
        //#  error "No Thread Local Storage (TLS) technology supported for this platform. Use sequential build !"
-       #define TMCThreadLocal 
+       #define TMCThreadLocal