--- Portfile.orig	2014-10-13 13:32:38.000000000 +0200
+++ Portfile	2014-10-14 11:53:11.000000000 +0200
@@ -5,8 +5,7 @@
 PortGroup           github 1.0
 
 name                xraylib
-version             3.0.0
-revision            1
+version             3.1.0
 categories          science
 platforms           darwin
 license             BSD
@@ -25,8 +24,8 @@
 master_sites        http://lvserver.ugent.be/xraylib/ \
                     http://xraylib.s3.amazonaws.com/
 
-checksums           rmd160  6c8c82c0afe3664adcd044a4371229a76bad5bf9 \
-                    sha256  0cc506e15f2f3563384dcb97cb4f9399b13d90f074b54c8d25cd59b7804d8636
+checksums           rmd160  17b96096244b9033f45bb3b630b3cc505a67c99b \
+                    sha256  61a7c7fd0a911562151422bc6ca77df8beba37ec4e337765cf60dfbe1e04a1e3 
 
 configure.args      --disable-idl \
                     --disable-fortran2003 \
@@ -34,81 +33,82 @@
                     --disable-python \
                     --disable-java \
                     --disable-lua \
-                    --disable-ruby
+                    --disable-ruby \
+                    --disable-python-numpy
 
 # to be fixed in later versions of xraylib...
 use_parallel_build  no
 configure.ccache    no
 
 
-variant perl5_10 description {Perl 5.10 bindings} conflicts perl5_12 perl5_14 perl5_16 perl5_18 { 
+variant perl5_10 description {Perl 5.10 bindings} conflicts perl5_12 perl5_14 perl5_16 perl5_18 perl5_20 { 
     configure.args-append --enable-perl --enable-perl-integration PERL=${prefix}/bin/perl5.10
     configure.args-delete --disable-perl
     depends_build-append port:swig-perl
     depends_lib-append port:perl5.10
 }
 
-variant perl5_12 description {Perl 5.12 bindings} conflicts perl5_10 perl5_14 perl5_16 perl5_18 { 
+variant perl5_12 description {Perl 5.12 bindings} conflicts perl5_10 perl5_14 perl5_16 perl5_18 perl5_20 { 
     configure.args-append --enable-perl --enable-perl-integration PERL=${prefix}/bin/perl5.12
     configure.args-delete --disable-perl
     depends_build-append port:swig-perl
     depends_lib-append port:perl5.12
 }
 
-variant perl5_14 description {Perl 5.14 bindings} conflicts perl5_10 perl5_12 perl5_16 perl5_18 { 
+variant perl5_14 description {Perl 5.14 bindings} conflicts perl5_10 perl5_12 perl5_16 perl5_18 perl5_20 { 
     configure.args-append --enable-perl --enable-perl-integration PERL=${prefix}/bin/perl5.14
     configure.args-delete --disable-perl
     depends_build-append port:swig-perl
     depends_lib-append port:perl5.14
 }
 
-variant perl5_16 description {Perl 5.16 bindings} conflicts perl5_10 perl5_12 perl5_14 perl5_18 { 
+variant perl5_16 description {Perl 5.16 bindings} conflicts perl5_10 perl5_12 perl5_14 perl5_18 perl5_20 { 
     configure.args-append --enable-perl --enable-perl-integration PERL=${prefix}/bin/perl5.16
     configure.args-delete --disable-perl
     depends_build-append port:swig-perl
     depends_lib-append port:perl5.16
 }
 
-variant perl5_18 description {Perl 5.18 bindings} conflicts perl5_10 perl5_12 perl5_14 perl5_16 { 
+variant perl5_18 description {Perl 5.18 bindings} conflicts perl5_10 perl5_12 perl5_14 perl5_16 perl5_20 { 
     configure.args-append --enable-perl --enable-perl-integration PERL=${prefix}/bin/perl5.18
     configure.args-delete --disable-perl
     depends_build-append port:swig-perl
     depends_lib-append port:perl5.18
 }
 
-variant python26 description {Python 2.6 bindings} conflicts python27 python31 python32 python33 {
-    configure.args-append --enable-python --enable-python-integration PYTHON=${prefix}/bin/python2.6
-    configure.args-delete --disable-python
-    depends_build-append port:swig-python
-    depends_lib-append port:python26
-}
-
-variant python27 description {Python 2.7 bindings} conflicts python26 python31 python32 python33 {
-    configure.args-append --enable-python --enable-python-integration PYTHON=${prefix}/bin/python2.7
-    configure.args-delete --disable-python
-    depends_build-append port:swig-python
-    depends_lib-append port:python27
-}
-
-variant python31 description {Python 3.1 bindings} conflicts python27 python26 python32 python33 {
-    configure.args-append --enable-python --enable-python-integration PYTHON=${prefix}/bin/python3.1
-    configure.args-delete --disable-python
-    depends_build-append port:swig-python
-    depends_lib-append port:python31
-}
-
-variant python32 description {Python 3.2 bindings} conflicts python27 python31 python26 python33 {
-    configure.args-append --enable-python --enable-python-integration PYTHON=${prefix}/bin/python3.2
-    configure.args-delete --disable-python
-    depends_build-append port:swig-python
-    depends_lib-append port:python32
-}
-
-variant python33 description {Python 3.3 bindings} conflicts python27 python31 python26 python32 {
-    configure.args-append --enable-python --enable-python-integration PYTHON=${prefix}/bin/python3.3
-    configure.args-delete --disable-python
-    depends_build-append port:swig-python
-    depends_lib-append port:python33
+variant perl5_20 description {Perl 5.20 bindings} conflicts perl5_10 perl5_12 perl5_14 perl5_16 perl5_18 { 
+    configure.args-append --enable-perl --enable-perl-integration PERL=${prefix}/bin/perl5.20
+    configure.args-delete --disable-perl
+    depends_build-append port:swig-perl
+    depends_lib-append port:perl5.20
+}
+
+variant python26 description {Python 2.6 bindings} conflicts python27 python33 python34 {
+    configure.args-append --enable-python --enable-python-integration --enable-python-numpy PYTHON=${prefix}/bin/python2.6
+    configure.args-delete --disable-python --disable-python-numpy
+    depends_build-append port:swig-python port:py26-cython
+    depends_lib-append port:python26 port:py26-numpy
+}
+
+variant python27 description {Python 2.7 bindings} conflicts python26 python33 python34 {
+    configure.args-append --enable-python --enable-python-integration --enable-python-numpy PYTHON=${prefix}/bin/python2.7
+    configure.args-delete --disable-python --disable-python-numpy
+    depends_build-append port:swig-python port:py27-cython
+    depends_lib-append port:python27 port:py27-numpy
+}
+
+variant python33 description {Python 3.3 bindings} conflicts python27 python26 python34 {
+    configure.args-append --enable-python --enable-python-integration --enable-python-numpy PYTHON=${prefix}/bin/python3.3
+    configure.args-delete --disable-python --disable-python-numpy
+    depends_build-append port:swig-python port:py33-cython
+    depends_lib-append port:python33 port:py33-numpy
+}
+
+variant python34 description {Python 3.4 bindings} conflicts python27 python26 python33 {
+    configure.args-append --enable-python --enable-python-integration --enable-python-numpy PYTHON=${prefix}/bin/python3.4
+    configure.args-delete --disable-python --disable-python-numpy
+    depends_build-append port:swig-python port:py34-cython
+    depends_lib-append port:python34 port:py34-numpy
 }
 
 variant ruby18 description {Ruby 1.8.7 bindings} conflicts ruby19 ruby20 ruby21 {
@@ -150,42 +150,49 @@
     depends_lib-append port:lua
 }
 
-variant gcc44 description {Build with gfortran from GCC 4.4} conflicts gcc45 gcc46 gcc47 gcc48 {
+variant gcc44 description {Build with gfortran from GCC 4.4} conflicts gcc45 gcc46 gcc47 gcc48 gcc49 {
     configure.args-replace --disable-fortran2003 --enable-fortran2003
     depends_lib-append path:lib/libgcc/libgcc_s.1.dylib:libgcc
     depends_build-append port:gcc44
     configure.fc ${prefix}/bin/gfortran-mp-4.4
 }
 
-variant gcc45 description {Build with gfortran from GCC 4.5} conflicts gcc44 gcc46 gcc47 gcc48 {
+variant gcc45 description {Build with gfortran from GCC 4.5} conflicts gcc44 gcc46 gcc47 gcc48 gcc49 {
     configure.args-replace --disable-fortran2003 --enable-fortran2003
     depends_lib-append path:lib/libgcc/libgcc_s.1.dylib:libgcc
     depends_build-append port:gcc45
     configure.fc ${prefix}/bin/gfortran-mp-4.5
 }
 
-variant gcc46 description {Build with gfortran from GCC 4.6} conflicts gcc44 gcc45 gcc47 gcc48 {
+variant gcc46 description {Build with gfortran from GCC 4.6} conflicts gcc44 gcc45 gcc47 gcc48 gcc49 {
     configure.args-replace --disable-fortran2003 --enable-fortran2003
     depends_lib-append path:lib/libgcc/libgcc_s.1.dylib:libgcc
     depends_build-append port:gcc46
     configure.fc ${prefix}/bin/gfortran-mp-4.6
 }
 
-variant gcc47 description {Build with gfortran from GCC 4.7} conflicts gcc44 gcc45 gcc46 gcc48 {
+variant gcc47 description {Build with gfortran from GCC 4.7} conflicts gcc44 gcc45 gcc46 gcc48 gcc49 {
     configure.args-replace --disable-fortran2003 --enable-fortran2003
     depends_lib-append path:lib/libgcc/libgcc_s.1.dylib:libgcc
     depends_build-append port:gcc47
     configure.fc ${prefix}/bin/gfortran-mp-4.7
 }
 
-variant gcc48 description {Build with gfortran from GCC 4.8} conflicts gcc44 gcc45 gcc46 gcc47 {
+variant gcc48 description {Build with gfortran from GCC 4.8} conflicts gcc44 gcc45 gcc46 gcc47 gcc49 {
     configure.args-replace --disable-fortran2003 --enable-fortran2003
     depends_lib-append path:lib/libgcc/libgcc_s.1.dylib:libgcc
     depends_build-append port:gcc48
     configure.fc ${prefix}/bin/gfortran-mp-4.8
 }
 
-if {![variant_isset python26] && ![variant_isset python27] && ![variant_isset python31] && ![variant_isset python32] && ![variant_isset python33]} {
+variant gcc49 description {Build with gfortran from GCC 4.9} conflicts gcc44 gcc45 gcc46 gcc47 gcc48 {
+    configure.args-replace --disable-fortran2003 --enable-fortran2003
+    depends_lib-append path:lib/libgcc/libgcc_s.1.dylib:libgcc
+    depends_build-append port:gcc49
+    configure.fc ${prefix}/bin/gfortran-mp-4.9
+}
+
+if {![variant_isset python26] && ![variant_isset python27] &&  ![variant_isset python33] && ![variant_isset python34]} {
     default_variants    +python27
 }
 